Attribute VB_Name = "modLineDraw"
Option Explicit
Dim dx, dy As Integer
Dim X, Y As Integer
Dim m As Double

Public Sub SimpleDraw()
'Simple Line Drawing Algorithm
Dim double_y As Double
      
    initPaint
    paintPixel X, Y
    If lineWidth > 1 Then
        thickPaint X, Y
    End If
    
    For X = x0 To x1
        double_y = m * X + y0
        Y = Round(double_y)
    paintPixel X, Y
    If lineWidth > 1 Then
        thickPaint X, Y
    End If
    Next X
    
End Sub

Public Sub DDADraw()
Dim double_y As Double
Dim i As Integer
    
    initPaint
    paintPixel X, Y
    
    If lineWidth > 1 Then
        thickPaint X, Y
    End If
    
    i = 1
    For X = x0 To x1
        double_y = y0 + (i * m)
        Y = Round(double_y)
        i = i + 1
    
    paintPixel X, Y
    
    If lineWidth > 1 Then
        thickPaint X, Y
    End If
    
    Next X
End Sub


Public Sub BADraw()
'Bresenhams Line Drawing Algorithm

Dim twice_d As Integer
       
    initPaint
    paintPixel X, Y
    
    If lineWidth > 1 Then
        thickPaint X, Y
    End If
    
    twice_d = 2 * dy - dx
    
    For X = x0 To x1
        If (twice_d >= 0) Then
            'Choose NE
            Y = Y + 1
            twice_d = twice_d + 2 * (dy - dx)
        Else
            'Choose E
            Y = Y
            twice_d = twice_d + 2 * dy
        End If
    
    paintPixel X, Y
    
    If lineWidth > 1 Then
        thickPaint X, Y
    End If
    
    Next X
End Sub

Private Sub initPaint()
    dx = x1 - x0
    dy = y1 - y0
    m = dy / dx
    If (m < 0 Or m > 1) Then
        MsgBox ("Value of m < 0 or > 1" & Chr(13) & "May Not Work Properly!!!")
    End If
    X = x0
    Y = y0
End Sub

